package dev.shadowsoffire.apotheosis.village.fletching.arrows;

import net.minecraft.world.phys.EntityHitResult;
import net.minecraft.world.entity.Entity;
import net.minecraftforge.network.NetworkHooks;
import net.minecraft.network.protocol.game.ClientGamePacketListener;
import net.minecraft.network.protocol.Packet;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.LivingEntity;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.projectile.AbstractArrow;

public class ObsidianArrowEntity extends AbstractArrow
{
    public ObsidianArrowEntity(final EntityType<? extends AbstractArrow> t, final Level world) {
        super((EntityType)t, world);
    }
    
    public ObsidianArrowEntity(final Level world) {
        super((EntityType)Apoth.Entities.OBSIDIAN_ARROW.get(), world);
    }
    
    public ObsidianArrowEntity(final LivingEntity shooter, final Level world) {
        super((EntityType)Apoth.Entities.OBSIDIAN_ARROW.get(), shooter, world);
    }
    
    public ObsidianArrowEntity(final Level world, final double x, final double y, final double z) {
        super((EntityType)Apoth.Entities.OBSIDIAN_ARROW.get(), x, y, z, world);
    }
    
    protected ItemStack m_7941_() {
        return new ItemStack((ItemLike)Apoth.Items.OBSIDIAN_ARROW.get());
    }
    
    public Packet<ClientGamePacketListener> m_5654_() {
        return (Packet<ClientGamePacketListener>)NetworkHooks.getEntitySpawningPacket((Entity)this);
    }
    
    protected void m_5790_(final EntityHitResult res) {
        final double base = this.m_36789_();
        this.m_36781_(base * 1.2000000476837158);
        super.m_5790_(res);
        this.m_36781_(base);
    }
}
